#version 330 core
in vec3 vertColor;
out vec4 outColor;


uniform vec2 dimensions;
uniform float radius;
uniform vec2 uv;
uniform vec2 position;
uniform float borderWidth;
uniform vec3 color;

float sdRoundedBox( in vec2 p, in vec2 b, in vec4 r)
{
    r.xy = (p.x>0.0)?r.xy : r.zw;
    r.x  = (p.y>0.0)?r.x  : r.y;
    vec2 q = abs(p)-b+r.x;
    return min(max(q.x,q.y),0.0) + length(max(q,0.0)) - r.x;
}

void main() {
    vec2 p = (2.0*gl_FragCoord.xy-uv.xy)/uv.y;
    p -= position;
    float d = sdRoundedBox( p, dimensions, vec4(radius) );
    vec3 col = color;
    if (d > 0)
        discard;
    if (d > -borderWidth)
        col = col - vec3(0.2, 0.2, 0.2);
    outColor = vec4(col, 1.0);
}
