package canvases;

import lwjglutils.OGLTextRenderer;
import model.Canvas;
import model.Window;
import renderer.AbstractRenderer;
import renderer.ShaderRenderer;
import ui.components.UIButton;
import ui.components.UILabel;
import ui.components.UIPlaceholder;
import ui.utils.UITextAlign;

import java.awt.*;

import static org.lwjgl.glfw.GLFW.glfwSetWindowShouldClose;

public class MainMenu extends Canvas implements CalculatingFPS {
    private UILabel labelFPS;
    private long oldmils;
    private int cycle = 0;
    private AbstractRenderer renderer;
    public MainMenu(int width, int height, ShaderRenderer renderer) {
        super(width, height, new OGLTextRenderer(width, height, new Font("Arial", Font.PLAIN, 20)));
        this.renderer = renderer;
        UIButton button = new UIButton(0.5f, 0.2f, -.975f, -.95f, new Color(0, 0, 0), this, "Ukončit");
        UIButton button2 = new UIButton(0.5f, 0.2f, -.975f, .65f, new Color(0, 0, 0), this, "Fraktál");
        UIButton button3 = new UIButton(0.5f, 0.2f, -.975f, .25f, new Color(0, 0, 0), this, "Ukázka 1");
        UIButton button4 = new UIButton(0.5f, 0.2f, -.975f, -.15f, new Color(0, 0, 0), this, "Ukázka 2");
        UILabel label = new UILabel(0.5f, 0.5f, 0.1f, -0.95f, "Ray Marching by Daniel Paleček", this, UITextAlign.CENTER_X);
        UIPlaceholder placeholder = new UIPlaceholder(0.55f, 2f, -1f, -1f, new Color(172, 172, 172), this);
        button.setListener((button1, action) -> {
            if (action == 1) {
                glfwSetWindowShouldClose(Window.window, true);
            }
        });
        button2.setListener((button1, action) -> {
            if (action == 1) {
                renderer.setSceneId(1);
            }
        });
        button3.setListener((button1, action) -> {
            if (action == 1) {
                renderer.setSceneId(2);
            }
        });
        button4.setListener((button1, action) -> {
            if (action == 1) {
                renderer.setSceneId(3);
            }
        });
        button.setRadius(0.1f);
        button2.setRadius(0.1f);
        button3.setRadius(0.1f);
        button4.setRadius(0.1f);
        labelFPS = new UILabel(0.5f, 0.75f, 0, 0.9f, "fps", this, UITextAlign.CENTER);
        this.addComponent(labelFPS);
        this.addComponent(label);
        this.addComponent(placeholder);
        this.addComponent(button);
        this.addComponent(button2);
        this.addComponent(button3);
        this.addComponent(button4);

        this.resize(width, height);
        oldmils = System.currentTimeMillis();
    }
    public void calculateFPS() {
        long mils = System.currentTimeMillis();
        if (mils - oldmils > 1000) {
            labelFPS.setText("FPS: " + cycle);
            cycle = 0;
            oldmils = mils;
        }
        cycle++;
    }
}
