package canvases;

import lwjglutils.OGLTextRenderer;
import model.Canvas;
import renderer.AbstractRenderer;
import renderer.ShaderRenderer;
import ui.components.UILabel;
import ui.components.UIPlaceholder;
import ui.utils.UITextAlign;
import java.awt.*;

public class SceneCanvas extends Canvas implements CalculatingFPS {
    private UILabel labelFPS;
    private long oldmils;
    private int cycle = 0;
    private AbstractRenderer renderer;
    public SceneCanvas(int width, int height, ShaderRenderer renderer) {
        super(width, height, new OGLTextRenderer(width, height, new Font("Arial", Font.PLAIN, 20)));
        this.renderer = renderer;

        UILabel label1 = new UILabel(0.5f, 0.5f, -0.95f, -0.55f, "pohyb - WSAD", this, UITextAlign.NONE);
        UILabel label2 = new UILabel(0.5f, 0.5f, -0.95f, -0.75f, "zrychlení - Space", this, UITextAlign.NONE);
        UILabel label3 = new UILabel(0.5f, 0.5f, -0.95f, -0.95f, "návrat do menu - Escape", this, UITextAlign.NONE);
        UIPlaceholder placeholder = new UIPlaceholder(0.8f, 0.6f, -1f, -1f, new Color(255, 255, 255), this);


        labelFPS = new UILabel(0.5f, 0.75f, 0, 0.9f, "fps", this, UITextAlign.CENTER);
        this.addComponent(labelFPS);
        label1.setTextColor(new Color(0, 0, 0));
        label2.setTextColor(new Color(0, 0, 0));
        label3.setTextColor(new Color(0, 0, 0));
        this.addComponent(label1);
        this.addComponent(label2);
        this.addComponent(label3);
        this.addComponent(placeholder);

        this.resize(width, height);
        oldmils = System.currentTimeMillis();
    }
    public void calculateFPS() {
        long mils = System.currentTimeMillis();
        if (mils - oldmils > 1000) {
            labelFPS.setText("FPS: " + cycle);
            cycle = 0;
            oldmils = mils;
        }
        cycle++;
    }
}
