package model;

import renderer.ShaderRenderer;
import transforms.Vec2D;

import java.awt.event.KeyEvent;
import static org.lwjgl.glfw.GLFW.GLFW_KEY_ESCAPE;


public class Controller {
    private ShaderRenderer renderer;
    private Scene scene;
    private boolean w, s, a, d, up, down, rightBtn, fast;
    private int sceneId = 0;
    private Vec2D mousePosHold, mousePosChange;
    public Controller() {
        scene = new Scene();

        renderer = new ShaderRenderer(scene, this);
        new Window(renderer);

    }

    public void keyPressed(int key) {

        if (key == KeyEvent.VK_W) {
            w = true;
        }
        if (key == KeyEvent.VK_S) {
            s = true;
        }
        if (key == KeyEvent.VK_A) {
            a = true;
        }
        if (key == KeyEvent.VK_D) {
            d = true;
        }
        if (key == KeyEvent.VK_E) {
            up = true;
        }
        if (key == KeyEvent.VK_Q) {
            down = true;
        }
        if (key == KeyEvent.VK_SPACE) {
            fast = true;
        }
        if (key == GLFW_KEY_ESCAPE) {
            renderer.setSceneId(0);
        }

    }
    public void keyReleased(int key) {

        if (key == KeyEvent.VK_W) {
            w = false;
        }
        if (key == KeyEvent.VK_S) {
            s = false;
        }
        if (key == KeyEvent.VK_A) {
            a = false;
        }
        if (key == KeyEvent.VK_D) {
            d = false;
        }
        if (key == KeyEvent.VK_E) {
            up = false;
        }
        if (key == KeyEvent.VK_Q) {
            down = false;
        }
        if (key == KeyEvent.VK_SPACE) {
            fast = false;
        }
    }

    public void mouseBtnPressed(int button, double x, double y) {

        if (button == 1)
            rightBtn = true;
        mousePosHold = new Vec2D(x, y);

    }

    public void mouseBtnReleased(int button, double x, double y) {

        if (button == 1)
            rightBtn = false;
        mousePosHold = null;

    }

    public void changeMousePos(double x, double y) {
        if (rightBtn) {
            scene.rotate(new Vec2D(mousePosHold.getX() - x, mousePosHold.getY() - y));
            mousePosHold = new Vec2D(x, y);
        }

    }

    public boolean[] isMoving() {
        return new boolean[]{w,s,a,d,up,down, fast};
    }
}
