package ui.components;

import model.Canvas;

public abstract class UIComponent {

    protected Canvas canvas;
    protected float componentWidth, componentHeight, correctedHeight, correctedWidth;
    protected float x, y;

    public UIComponent(float componentWidth, float componentHeight, float posX, float posY, Canvas canvas){
        this.componentWidth = componentWidth;
        this.componentHeight = componentHeight;
        this.x = posX;
        this.y = posY;
        this.canvas = canvas;

    }
    public UIComponent(Canvas canvas){
        this.componentWidth = 2;
        this.componentHeight = 2;
        this.x = -1;
        this.y = -1;
        this.canvas = canvas;
    }

    public float getComponentWidth() {
        return componentWidth;
    }

    public void setComponentWidth(float componentWidth) {
        this.componentWidth = componentWidth;
    }

    public float getComponentHeight() {
        return componentHeight;
    }

    public void setComponentHeight(float componentHeight) {
        this.componentHeight = componentHeight;
    }

    public float getX() {
        return x;
    }

    public void setX(float x) {
        this.x = x;
    }


    public float getY() {
        return y;
    }

    public void setY(float y) {
        this.y = y;
    }

    public abstract void render();

    public abstract void resize(int width, int height);

}
